//FurSVG.js

/*
Версия 1.0.0.5 Дата 17.02.2024
*/

var svgDocument;
var object;
var Name;
var Gr;		//образ чистого холста
var NumLine;
var NX;
var NY;
var point;
//инициализация
function InitGrarhSVG(ID,szX, szY) {
	Name = ID;
	object = document.getElementById(Name);
	svgDocument = object.contentDocument;
	point = object.createSVGPoint();
	point.MouseOver = false;
	point.MouseEnter = false;
	point.MouseOut = false;
	point.MouseLeave = false;
	point.MouseMove = false;
	point.MouseClick = false;
	point.MouseDown = false;
	point.MouseUp = false;
	point.MouseInBorders = false;
	object.addEventListener("click", SVGclick);
	object.addEventListener("mouseover", SVGmouseover);
	object.addEventListener("mouseenter", SVGmouseenter);
	object.addEventListener("mouseout", SVGmouseout);
	object.addEventListener("mouseleave", SVGmouseleave);
	object.addEventListener("mousemove", SVGmousemove);
	object.addEventListener("mousedown", SVGmousedown);
	object.addEventListener("mouseup", SVGmouseup);
	NX = szX;
	NY = szY;
	Gr = document.getElementById(Name).innerHTML;
}

function SetPatternSVG() {
	Gr = document.getElementById(Name).innerHTML;
}
function ReadPatternSVG() {
	return document.getElementById(Name).innerHTML;
}
function ClearGraphSVG() {
	document.getElementById(Name).innerHTML = Gr;
}
// рисование линии
function DrawLine(id, x1, y1, x2, y2, px, col) {
	var line = document.createElementNS("http://www.w3.org/2000/svg", 'line');
	line.setAttribute('id', id);
	line.setAttribute('x1',x1);
	line.setAttribute('y1',y1);
	line.setAttribute('x2',x2);
	line.setAttribute('y2',y2);
	line.setAttribute('stroke', col);
	line.setAttribute('stroke-width', px);
	document.querySelector('#' + Name).append(line);
}
//римование прямоугольника
function DrawRectangle(id, x1, y1, width1, height1, stroke1, fill1, opacity1) {
	var rect = document.createElementNS("http://www.w3.org/2000/svg", 'rect');
	rect.setAttribute('id',id);
	rect.setAttribute('x',x1);
	rect.setAttribute('y',y1);
	rect.setAttribute('width',width1);
	rect.setAttribute('height',height1);
	rect.setAttribute('stroke', stroke1);
	rect.setAttribute('fill', fill1);
	rect.setAttribute('opacity', opacity1);
	document.querySelector('#' + Name).append(rect);
}
//вывод текста
function DrawText(id, x, y, fontsz, col, val) {
	var text = document.createElementNS("http://www.w3.org/2000/svg", 'text');
	text.setAttribute('id', id);
	text.setAttribute('x',x);
	text.setAttribute('y',y);
	text.innerHTML = val;
	text.style = "font-family:FreeSerif;font-weight:normal;font-size:" + fontsz + ";fill:" + col;
	document.querySelector('#' + Name).append(text);
}
//
function SVGclick(evt) {
	point.MouseClick = true;
	var mp = point.matrixTransform(this.getScreenCTM().inverse());
	point.x = parseInt(mp.x);
	point.y = parseInt(mp.y);
	point.MouseInBorders = true;
}
function SVGmouseover(evt) {
	point.MouseOver = true;
	point.MouseOut = false;
	point.x = evt.clientX;
	point.y = evt.clientY;
	var mp = point.matrixTransform(this.getScreenCTM().inverse());
	point.x = parseInt(mp.x);
	point.y = parseInt(mp.y);
	point.MouseInBorders = true;
}
function SVGmouseenter(evt) {
	point.MouseEnter = true;
	point.MouseLeave = false;
	point.x = evt.clientX;
	point.y = evt.clientY;
	var mp = point.matrixTransform(this.getScreenCTM().inverse());
	point.x = parseInt(mp.x);
	point.y = parseInt(mp.y);
	point.MouseInBorders = true;
}
function SVGmouseout(evt) {
	point.MouseOver = false;
	point.MouseOut = true;
	point.MouseMove = false;
	point.MouseInBorders = false;
}
function SVGmouseleave(evt) {
	point.MouseLeave = true;
	point.MouseEnter = false;
	point.MouseMove = false;
	point.MouseInBorders = false;
}
function SVGmousedown(evt) {
	point.MouseDown = true;
	point.MouseUp = false;
	point.x = evt.clientX;
	point.y = evt.clientY;
	var mp = point.matrixTransform(this.getScreenCTM().inverse());
	point.x = parseInt(mp.x);
	point.y = parseInt(mp.y);
	point.MouseInBorders = true;
}
function SVGmouseup(evt) {
	point.MouseUp = true;
	point.MouseDown = false;
	point.x = evt.clientX;
	point.y = evt.clientY;
	var mp = point.matrixTransform(this.getScreenCTM().inverse());
	point.x = parseInt(mp.x);
	point.y = parseInt(mp.y);
	point.MouseInBorders = true;
}
//
function SVGmousemove(evt) {
	point.MouseMove = true;
	point.x = evt.clientX;
	point.y = evt.clientY;
	var mp = point.matrixTransform(this.getScreenCTM().inverse());
	point.x = parseInt(mp.x);
	point.y = parseInt(mp.y);
	point.MouseInBorders = true;
}

function GetSVGPoint() {
	return point;
}

